
/*                       ****************
			 * EAGLE EMPIRE *
			 ****************

Autor: 		Allan Tengg
Klasse:         2AHI
SOUD-Update:    3AHI

Bemerkung:  * Speichermodell TINY oder SMALL verwenden
	    * Man mu das Projektfile compilieren
	    * Im Projektfile ist EAGLE.C und MODEX.OBJ
	    * VGA-Karte bentigt
	    * Empfohlen mind. 386/33 (Code enthlt 286'er Befehle)
	    * Keine Floatingpoint-Operationen (Zeit, keine Verwendung)
	    * alle CHAR sind UNSIGNED CHAR mu deaktiviert werden!
*/

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <alloc.h>
#include "voclib.h"
#include "modex.h"
#include "eagle.fnt"
#include "sprites.eag"

typedef struct {word x;      //x-Position
		word y;      //y-Position
		byte s;}STAR;//Geschwindigkeit

typedef struct {int x;             //x-Pos
		int y;             //y-Pos
		word score;         //Punktezahl
		char lives;}SPIELER;//Leben

typedef struct{int  x;              //x-Pos
	       int  y;              //y-Pos
	       byte timer;          //Zhlvariable
	       byte status;         //Animationszustand
	       int  xspeed;         //Geschwindigkeitx  //
	       char yspeed;         //Geschwindigkeity   //Kann auch neg. sein
	       byte dead;           //Flag dead=0 ... lebend; dead=1 ... tot
				    //dead=2...zerreiend; dead=3...verletzt
	       byte move;           //wie oft in dieselbe Richtung bewegen
	       byte shit;           //Shit (Scheie) - Gegenangriff
	       int shitx;           //Position der Scheie
	       int shity;}EAGLE;

//**************** GLOBALE VARIABLEN: ***************************************

 byte extern page;
 byte extern sample;
 byte extern compression;
 byte extern timeconst;
 word extern offset;
 char leer[8*6*8+5];        //Ein leerer Sprite zum lschen von Text
 byte _kill[12753];
 word _killsize;
 byte _hurt[4455];
 word _hurtsize;

 SPIELER player;               //einen Spieler definieren
 void interrupt (*olddma)();//Zeiger wo der alte DMA-INT ist
			    //wird. Ich verwende meinen eigenen:
 char string[25];           //Fr Strings zum buffern
 byte anzahl;               //Anzahl der lebenden Adler
 byte level=0;              //Level=Anzahl d. Adler

//********************* PROCEDUREN ******************************************

void interrupt mydma(void)
{
 writedsp(0xd3);
 outportb(0x20,0x20);
}

void loadvoc(char *filename, char *vocdata, word *size)
{
 FILE *VOC;
 VOCHEADER header;
 VOCDATABLOCK databl;

 if (resetdsp()==-1) return -255;
 VOC=fopen(filename,"rb");                         //File ffnen
 fread (&header,sizeof(VOCHEADER),1,VOC);          //Header lesen
 fseek (VOC,header.ofst[1]*256+header.ofst[0],0);  //DatenBlock positionieren
 fread (&databl,sizeof(VOCDATABLOCK),1,VOC);       //DatenBlock lesen
 *size=databl.size[0]+(word)databl.size[1]*256;
 sample=getc(VOC);
 compression=getc(VOC);
 timeconst=256-((long)100000/(long)sample);
 fread(vocdata,1,(*size+2),VOC);      //Daten einlesen
 fclose(VOC);
 return 0;
}

void loadsounds()
{
 loadvoc("kill.voc",_kill,&_killsize);
 _killsize-=170;
 loadvoc("hurt.voc",_hurt,&_hurtsize);
 _hurtsize-=150;
}

void interrupt key()  // Meine eigener Tastaturinterrupt:
{                     // Er tut gar nichts!
 outportb(0x20,0x20); //Fhrt eine Art RESET am Tastaturcontroller aus
}

//***************************************************************************

void palette()      //Bei 256 Farben ist es schwer zu sagen, welches Attribut
{                   //welche Farbe ist. Am besten man definiert es selbst:
 rgb (8,20,20,20); //
 rgb (9,30,30,30); //
 rgb (13,10,0,30); //
 rgb (4,40,40,40); // PALETTE FR RAUMSCHIFF
 rgb (5,50,50,50); //
 rgb (6,50,10,10); //
 rgb (7,60,60,60); //

 rgb (10,45,10,0); //
 rgb (11,50,44,0); // PALETTE FR DSEN
 rgb (12,60,60,10);//

 rgb (210,50,20,10);//berschrift
 rgb (211,63,63,0);

 rgb (2,0,0,50);    //Adler
 rgb (1,50,50,63);  //
 rgb (3,30,15,10);  //

 rgb (255,0,0,0);   //Ersatz fr Schwarz mit Atribut 0

 rgb (14,63,63,10); //fr shit
}

//*****************++INTRO++***********************************************
void intro()
{
 PCX a;                 //is not used (but it coud be used!)
 word i;

 setmodex();
 outportb(0x3c2,(inportb(0x3cc)&63)|128);
 viewpage(0);
 loadpcx(70,110,"eoa.dat",&a,1);
 rgb (100,63,10,10);
 rgb (101,63,63,63);
 print (70,170,100,1,"WHAT A FANTASTIC GROUP",0,char1);
 for (i=0; i<=16000; i+=80)
 {
  setlstart(i);
  raster();
 }
 print (45,30,100,1,"ALLAN TENGG PROUDLY PRESENTS:",0,char1);
 delay(999);
 print (101,50,101,1,"EAGLE EMPIRE",0,char1);
 getkeyb();
}

//**************************************************************************

byte getkey()      //liest direkt ein Zeichen vom Tastaturcontroller
{
 unsigned char c;
 c=inportb(0x60);
 if ((c&128)==128) c=0;
 return c;
}

//***************************************************************************
void printstatus()
{
 print(130,0,210,0,"LEVEL:",0,char1);
 print(130,0,210,2,"LEVEL:",0,char1);
 print (20,0,210,0,"SCORE:",0,char1);  //
 print (240,0,210,0,"LIVES:",0,char1); //
 print (20,0,210,2,"SCORE:",0,char1);  //Mu auf ALLEN Seiten geschrieben sein
 print (240,0,210,2,"LIVES:",0,char1); //
 xline (0,319,9,210,0);  //Abschlulinie
 xline (0,319,9,210,2);
}

//***************************************************************************

void clearplay(byte page)
{
 asm{MOV AX,0xa000  //Bildschirmstart = $A000:0000
     MOV ES,AX
     MOV BL,page    //Jede Seite hat 16000 Bytes
     XOR BH,BH
     MOV AX,16000   //D.h. Seite * 16000 = reative Startadresse
     MUL BX
     MOV DI,AX
     ADD DI,10*80    //Dann noch +80*10 damit die INFO-Zeile bleibt
     MOV DX,TS      //alle vier Bitplanes auf einmal beschreiben
     MOV AL,2
     OUT DX,AL
     INC DX
     IN AL,DX
     OR AL,0x0f
     OUT DX,AL     //An die Grafikkarte schicken
     CLD
     MOV CX,8000-10*40 //Und speicher mit $00 berschreiben
     MOV AX,0x0000
     REP STOSW}       //Und das (16000-80*10)/2, denn gleich Integer schreiben
		      //geht schneller
}

//***************************************************************************

void statusp(SPIELER a) //gibt die Punktezahl aus
{
 putxsprite (76,0,0,leer);//zuerst die alte POS freimachen
 putxsprite (76,0,2,leer);
 sprintf(string,"%u",a.score);      //Dann in einen String kopieren
 print (76,0,211,0,string,0,char1); //Und dann ausgeben
 print (76,0,211,2,string,0,char1); //auf beiden Seiten
}

void statusl(SPIELER a) //gibt die Leben aus
{
 string[0]=' '; string[1]=0;            //Zuerst weglschen
 print (240+56,0,255,0,string,1,char1);
 print (240+56,0,255,2,string,1,char1);
 sprintf(string,"%u",a.lives);          //Dann neu malen
 print (240+56,0,211,0,string,0,char1);
 print (240+56,0,211,2,string,0,char1);
}

void status(SPIELER a)  //Wenn man alles auf einmal braucht
{
 statusl(a);
 statusp(a);
}
//***************************************************************************

void drawadler(EAGLE *b,char page) //Zeichnet den Adler je nach Animation
				   //Schritt:
{
 switch (b->status)  //Ich habe kleine Probleme mit meinen Daten!
		    //Ich kann sie nicht in einem Array zusammenfassen,
		    //Da sie nicht immer gleich lang sind!
 {
  case 0: putxsprite (b->x,b->y,page,eagle3);
	  break;
  case 5:
  case 1: putxsprite (b->x,b->y,page,eagle4);
	  break;
  case 4:
  case 2: putxsprite (b->x,b->y,page,eagle5);
	  break;
  case 3: putxsprite (b->x,b->y,page,eagle6);
	  break;
 }
 b->timer++;                    //Bei jedem Durchlauf bewegen wirkt
 if (b->timer==5)               //nicht, desbalb nur bei jedem 5!
 {
  b->status++;                   //nchsten Animationsschritt
  if (b->status==6) b->status=0; //schon alle durch? Von forne anfangen!
  b->timer=0;                    //timer reset
 }
}

//*************************************************************************

void explosion (EAGLE *a,char page)//lt einen Adler zerreien
{
 register byte flag;              //zur Erkennung des Endes
 flag=0;
 if (a->x>0)
 {
  a->x-=3;			  //nur wenn er noch nicht am Rand ist bewegen
  putxsprite(a->x,a->y,page,eagle1);//und zeichnen
  flag++;                         //Flag=1
 }
 if (a->xspeed<319-25)
  {
   a->xspeed+=3;
   putxsprite(a->xspeed,a->y,page,eagle2);
   flag++;                        //Flag !=0
  }
 if (!flag)                       //Wenn alle Bewegungen fertig
  {
   a->dead=1;                     //Entgltig weg (vom Fenster)
   anzahl--;                      //1 Adler weniger
  }
}

//***************************************************************************

void baby(EAGLE *a)
{
 putxsprite (a->x,a->y,0,eagle8);  //Animationsschritte des wachsenden Adlers
 putxsprite (a->x,a->y,2,eagle8);
 delay(200);
 raster();
 putxsprite (a->x,a->y,0,eagle9);
 putxsprite (a->x,a->y,2,eagle9);
 delay(200);
 raster();
}

//***************************************************************************
// Mein Hauptprogramm (leider etwas lang geworden)
//***************************************************************************

void main()
{
		//rot,grn,blau   (0-63)
 byte colorinfo[]={0,0,50,      //blau
		   50,0,0,      //rot
		   0,50,0,      //grn
		   50,0,50,     //rosa
		   50,50,0,     //gelb
		   0,50,50,     //trkis
		   50,30,0,     //orange
		   30,30,30,    //grau1
		   15,15,15,    //grau2
		   40,20,20,    //braun
		   30,30,60,    //hellblau
		   62,30,30,    //hellrot
		   30,60,30,    //hellgrn
		   50,30,60,    //hellrosa
		   60,60,30,    //hellgelb
		   30,60,60,    //trkis (hell)
		   60,40,25};   //orange-hell

 const asterne=69;             //69+1 Sterne im Hintergrund
 byte intmask;
 EAGLE eagle[31];              //Fr 30 Adler Dimensionieren
 STAR strn[70];
 STAR shoot;                   //Stuct STAR fr einen Schu mibrauchen
 byte c,ch;                    //ein Zeichen
 word i;                       //Allgemeine Zhlvariable
 byte flip;                    //Flag zum toggeln des Bildschirms zwischen
 word scrof;                   //Seite 1 und Seite 3 von 4 Seiten
			       //Damit kein Clipping notwendig!
 register word z;              //Zum mitzhlen
 word color=0;                 //Zum mitzhlen der Farbe

 intro();                      //little Intro zeigen
 loadsounds();
//***Variablen initialisieren***

 randomize();                  //Zufallszahlengenerator initialisieren
 player.x=110;                 //
 player.y=199-35;              //x und y-Koordinaten des Spielers
 player.lives=5;               //5 Leben  (bin ja grozgig!)
 player.score=0;               //0 Punkte
 shoot.s=0;                    //kein Schu am Anfang
 for (z=1; z<=20; z++)
 {
  eagle[z].shit=0;                 //keine Scheie!
  eagle[z].x=random(318)+1;        //Adler Start
  eagle[z].y=random(130)+1;
  eagle[z].timer=0;                //Timer Reset
  eagle[z].status=0;               //Animationsschritt 0 beginnen
  eagle[z].move=20;                //20 Durchlufe warten
  eagle[z].xspeed=0;               //Stillstand
  eagle[z].yspeed=0;               //
  eagle[z].dead=0;                 //eagle[z] lebt
 }

 for (i=0; i<=8*6*8+4; i++)         ////
  leer[i]=255;                        // Leer wirklich leer machen
 leer[0]=0; leer[1]=8*6; //Lnge in x //
 leer[2]=0; leer[3]=8;   //Lnge in y //
			    ////

 for (i=0; i<=asterne; i++)    //Eine Anfangsposition fr alle Sterne
  {                            //berechnen
   strn[i].x=random(319);      //in x
   strn[i].y=random(189)+10;    //in y  (berschrift nicht zerstren)
   strn[i].s=random(2)+1;      //und die Geschw.
  }

 setmodex();                  //320x200x256 aktivieren
 outportb(0x3c2,(inportb(0x3cc)&63)|192);
 palette();                   //Palette herrichten
 flip=scrof=0;                //Flags auf 0 setzen

 asm CLI;
 intmask=inportb(0x21);
 olddma=getvect(0x0f);           //Alten Interrupt-Vector speichern
 setvect(0x0f,mydma);              //und dann auf eigenen verbiegen
 outportb(0x21,inportb(0x21)|2);   //key-interrupt
 outportb(0x21,inportb(0x21)&127); //DMA-Interrupt erlauben!
 asm STI;

 printstatus();               //Schreibt Leben u. Punktezahl
 status(player);              //Trgt Leben u. Punktezahl ein

 putxsprite (player.x,player.y,flip,spaceship); //Raumschiff

//**************************************************************************
//                       HAUPTSCHLEIFE
//**************************************************************************

do
 {
  level++;

  rgb (2,colorinfo[color],colorinfo[color+1],colorinfo[color+2]);
  color+=3;

  for (z=1; z<=level; z++)                        //Variablen neu festlegen
  {
   eagle[z].shit=0;                 //keine Scheie!
   eagle[z].x=random(318)+1;        //Adler Start
   eagle[z].y=random(130)+1;
   eagle[z].timer=0;                //Timer Reset
   eagle[z].status=0;               //Animationsschritt 0 beginnen
   eagle[z].move=20;                //20 Durchlufe warten
   eagle[z].xspeed=0;               //Stillstand
   eagle[z].yspeed=0;               //
   eagle[z].dead=0;                 //eagle[z] lebt
  }
  if (level>1)
   {
    print (90,50,211,0,"LEVEL COMPLETED",0,char1);
    print (40,80,210,0,"LET'S ENTER THE NEXT LEVEL...",0,char1);
    print (90,50,211,2,"LEVEL COMPLETED",0,char1);
    print (40,80,210,2,"LET'S ENTER THE NEXT LEVEL...",0,char1);
    delay(1700);
   }

  for(z=1; z<=level; z++)
   baby(&eagle[z]);				  //Adler werden geboren

  print(130+6*8,0,255,0,"  ",1,char1);            //Pos fr Level freimachen
  print(130+6*8,0,255,2,"  ",1,char1);
  sprintf(string,"%u",level);
  print(130+6*8,0,211,0,string,0,char1);
  print(130+6*8,0,211,2,string,0,char1);
  anzahl=level;                                       //|LEVEL| Adler


 do
 {
  clearplay(flip);                          //Spielfeld lschen
					  /////
  for (i=0; i<asterne; i++)                  // Sternenhimmel malen
     fastpp (strn[i].x,strn[i].y,15,scrof);  // Fast Put Pixel
					   ////

  putxsprite (player.x,player.y,flip,spaceship); //Raumschiff

  for (z=1; z<=level; z++)              //Alle Adler zeichnen
  {
   if(eagle[z].dead!=1)                    //Nur wenn lebendig
   {
    if (!eagle[z].dead)                   // Wenn Adler lebendig
    {
     drawadler(&eagle[z],flip);          // Dann Adler malen
     eagle[z].x+=eagle[z].xspeed;           // und anschlieend neue Pos Berechnen
     eagle[z].y+=eagle[z].yspeed;
     if (eagle[z].x>=320) eagle[z].x=0;     //Sicherheitsabfragen
     if (eagle[z].x<1) eagle[z].x=320;
     if (eagle[z].y>=199) eagle[z].y=11;
     if (eagle[z].y<11) eagle[z].y=11;
     eagle[z].move--;                    //Movement -1
     if (!eagle[z].move)                 //Wenn null
      {
       eagle[z].xspeed=random(5)-2;      //neue Werte
       eagle[z].yspeed=random(3)-1;
       eagle[z].move=random(30)+1;
       if (!eagle[z].shit &&           //Wenn keine Scheie, Chancen auf neue
	   random(20)==10)             //und wenn 10 aus 20 dann Scheie ein
	{
	 eagle[z].shit=1;                 //ein
	 eagle[z].shitx=eagle[z].x+24;    //Position
	 eagle[z].shity=eagle[z].y+20;
	}
      }
     }
     else
      if (eagle[z].dead==3)                          //verletzt
       {
	putxsprite (eagle[z].x,eagle[z].y,flip,eagle7);  //verstmmelter Adler
	eagle[z].y+=2;                                //Absturz
	if (eagle[z].y>=199)
	{
	 eagle[z].y=10;
	 eagle[z].dead=0;                            //Wieder gesund
	}
       }
      else
       if (eagle[z].dead==2)                         //Adler explodiert gerade
	explosion(&eagle[z],flip);                   //

// **************Bewegung des SHIT ******************
    if (eagle[z].shit)                 //nur wenn aktiv
     {
      if (eagle[z].shity<198)          //und kleiner als 198
       {
	eagle[z].shity+=2;              //dann bewegen
	fastpp(eagle[z].shitx,eagle[z].shity,14,scrof);  //und 3 Pixel plotten
	fastpp(eagle[z].shitx,eagle[z].shity+1,14,scrof);
	fastpp(eagle[z].shitx+1,eagle[z].shity,14,scrof);
	c=getpixel(eagle[z].shitx+1,eagle[z].shity+1,flip);
	if (c>=4 && c<=13)                             //He,he. Beschissen!
	{
	 player.lives--;                              //leben weniger
	 statusl(player);                             //neue Anzeige
	 eagle[z].y=12;                                  //von oben anf.
	 eagle[z].dead=0;                                //Vogel heilen
	 eagle[z].shit=0;                                //Scheie aufrumen
	 delay(900);
	}
       }
       else
	eagle[z].shit=0;                //sonst deaktivieren
      }

// ********PRFUNG AUF KOLLISSION********************

   if (eagle[z].dead!=1)              //nur gesunde suchen
    {
     if (eagle[z].dead==0)             //gesunder Adler
      {
       if (eagle[z].y>199-40 &&
	   (eagle[z].x+48>player.x && eagle[z].x<player.x+27||
	   eagle[z].x-272>player.x && eagle[z].x-320<player.x+27)) //koordinaten
       {                                                      //prfen
	player.lives--;
	statusl(player);
	eagle[z].y=12;
	eagle[z].dead=0;
	delay(900);
       }
      }
      else
       if (eagle[z].dead==3)              //Verletzter Adler ist kleiner
	{
	 if (eagle[z].y>199-40 &&
	     (eagle[z].x+36>player.x && eagle[z].x<player.x+15 ||
	     eagle[z].x-284>player.x && eagle[z].x-320<player.x+15))
	    ////Koordinaten prfen

	 {
	  player.lives--;
	  statusl(player);
	  eagle[z].y=12;
	  eagle[z].dead=0;
	  delay(900);
	 }
	}
     }
    }
  }                         //Ende der Adlerschleife

//****************SCHU Zeichnen und auf Treffer prfen*******************
  if (shoot.s)                                   //Nur wenn Schu aktiv
  {
   yline (shoot.y,shoot.y+6,shoot.x,6,flip);     //1.Linie und 2. Linie
   yline (shoot.y,shoot.y+6,shoot.x+28,6,flip);  //zeichnen
   c=getpixel(shoot.x,shoot.y-1,flip);           //Ist darunter ein Pixel?
   c+=getpixel(shoot.x+28,shoot.y-1,flip);
   if (c!=0 && c!=15 && c!=30)                   //Treffer!
   {
    for (z=1; z<=level; z++)         //Schauen welcher Adler getroffen
    {
     if (eagle[z].dead==0 || eagle[z].dead==3) //Nur nach lebendigen Adlern suchen
     {
      if (shoot.y<=eagle[z].y+21 &&
	  shoot.y+6>=eagle[z].y)
       {
	if (shoot.x+28>=eagle[z].x && shoot.x<=eagle[z].x+48 ||
	    shoot.x+348>=eagle[z].x && shoot.x+320<=eagle[z].x+48)
	 //if (shoot.x<=eagle[z].x+48)
	 {
	  if (eagle[z].dead==0)
	  {
	   eagle[z].dead=3;             //verletzt
	   resetdsp();
	   playblock(_hurt,_hurtsize-2);
	  }
	  else
	   if (eagle[z].dead==3)
	   {
	    eagle[z].dead=2;                            //zerreiend
	    eagle[z].xspeed=eagle[z].x+24; // Koordinaten fr zerreienden Adler
				     // (xspeed wird mibraucht)
	    player.score+=100;
	    statusp(player);
	    resetdsp();
	    playblock(_kill,_killsize-2);
	   }
	   shoot.s=0;
	 }

       }
     }
    }
   }
  }

//**************************************************************************

  for (i=0; i<asterne; i++)              //Sterne neue Pos-berechnen
  {
   strn[i].y+=strn[i].s;                 //Falls Stern unten ist
   if (strn[i].y>199)
    {
     strn[i].y=10;                        //wieder nach oben setzen
     strn[i].x=random(319);              //und neue x-Koordinate
    }
  }
  if (shoot.s)                           //Wenn Schu aktiv, dann
  {
   shoot.y-=2;                           //die y-Koordinate -2
   if (shoot.y<=11) shoot.s=0;           //und wenn er oben ist, deaktivieren
  }                                      //

  //raster();                            //
  viewpage(flip);                        //Wenn alles gezeichnet, dann toggeln
  raster();                              //Warten bis ein Retrace im Gage ist
					 //Verhindert Flackern zu 100% !!!!
  if (flip==0)                         ////flip und scrof toggeln
   {                                     //
    flip=2;                              //
    scrof=32000;                         //
   }                                     //
  else                                   //
   flip=scrof=0;                       ////

  ch=getkey();                                 //Taste holen und auswerten
  switch (ch)
  {
   case 75: if (player.x >2) player.x-=2;      //nach links mit Sicherheit
	    break;
   case 77: if (player.x <320-29) player.x+=2; //nach rechts mit Sicherheit
	    break;
   case 76: if (shoot.s==0)
	    {
	     shoot.s=1;                   //Schu abfeuern
	     shoot.x=player.x-1;          //Vorausgesetzt, es ist keiner aktiv
	     shoot.y=player.y+12;         //Koordinaten fr Schu festlegen
	     //playblock(_fire,_firesize);
	    }
  }
 }
 while (ch!=1 && anzahl && player.lives>0);   //Schleife fr Level
}while (ch!=1 && player.lives>0);             //Schleife fr nchsten Level

 rgb(209,40,40,63);
 setlstart(0);
 print(96,100,209,0,"GAME OVER!",0,char1);
 asm CLI;
 outportb(0x20,0x20); //Vor rcksetzen auf alten Interrupt einen RESET
 setvect(0x0f,olddma);   //dann wieder Tastaturinterrupt vom DOS verwenden
 outportb(0x21,intmask); //alter Status wiederherstellen
 asm STI;
 getkeyb();
 clear(1);              //Bildschirm 1 schwarz machen fr scrollen
 for (i=0; i<=16000; i+=80)  //Abscrollen des Spielfeldes
 {                           //sichtbaren Ausschnitt des Graphikspeichers
  raster();                  //von Seite 0 allmhlich auf Seite 1 stellen
  setlstart(i);              //(Set Linear Starting-Address)
 }
 delay(300);
 settext();     //Wieder in Textmodus zurckschalten
 asm STI;       //NMI-Interrupt wieder erlauben
 printf("Allan: Thanks for playing!\n");
}
